<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Rating extends Controller_UserEnvi {
    
    // Получить из кука SGID выбранную ранее группу
    private function GetSGID($id)
    {
        # $id = disciplineID
        $SG_ar = json_decode(Cookie::get('SGID', null), true);
        if ($SG_ar !== null) 
        {
            if (array_key_exists($id, $SG_ar))
                return $SG_ar[$id];
        }
        return 0;
    }

    public function action_edit()
    {
        $twig = Twig::factory('teacher/rating');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Rating;
		
        // Шапка таблицы: структура УКД (модули и мероприятия)
		$structure = $db->GetMapForDiscipline($this->UserInfo['TeacherID'], $id);

        if($structure->count() == 0)
            throw HTTP_Exception::factory (404, "Для дисциплины с ID $id не создана УКД или такой дисциплины не существует!");
        
		$structureHandled = array();
        $maxRate = 0; $i = 0; $module = 0;

        foreach($structure as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if ($i == 1)
                    $structureHandled['SubjectName'] = $row['SubjectName'];
            if(!isset($structureHandled[$i]['SubmodulesCount']))
            {
                $structureHandled[$i]['SubmodulesCount'] = 0;
                $structureHandled[$i]['MaxRate'] = 0;
            }
            $j = $structureHandled[$i]['SubmodulesCount'] += 1;
            $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
            if ($row['ModuleType'] == "exam")
                $twig->examSubmoduleID = $row['SubmoduleID'];
                    
            $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
            $structureHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $structureHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $structureHandled['ModulesCount'] = $i;
        $structureHandled['MaxRate'] = (int) $maxRate; 

        $twig->headerRate = $structureHandled;
        // end Шапка таблицы


        // Студенты и их баллы
        $students = $db->GetStudentsForRating($this->UserInfo['TeacherID'], $id);

        $studentsHandled = array();
        $i = 0; $curGroup = 0; $groups = array();

        foreach($students as $row) {
			$i++;
			$studentsHandled[$i]['ID'] = $row['ID'];
			$studentsHandled[$i]['Last'] = $row['Last'];
			$studentsHandled[$i]['First'] = $row['First'];
			$studentsHandled[$i]['Second'] = $row['Second'];
			$studentsHandled[$i]['GradeNum'] = $row['GradeNum'];

			if ($row['Degree'] == 'bachelor')
				$studentsHandled[$i]['GradeTitle'] = $row['GradeNum'].' курс';
			if ($row['Degree'] == 'specialist')
				$studentsHandled[$i]['GradeTitle'] = $row['GradeNum'].' курс';
			if ($row['Degree'] == 'master')
				$studentsHandled[$i]['GradeTitle'] = 'Магистратура, '.$row['GradeNum'].' год';

			$studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
			$studentsHandled[$i]['GroupID'] = $row['GroupID'];
			if ($row['GroupID'] != $curGroup) {
				$curGroup = $row['GroupID'];
				$groups[$curGroup] = $studentsHandled[$i]['GradeTitle']." ".$row['GroupNum']." группа"; 
			}

			$studentsHandled[$i]['isAttached'] = $row['isAttached'];
			$rate = $db->getMapForStudent($row['ID'], $id);
			$j = 0;
			foreach($rate as $r) {
					$j += 1;
					$studentsHandled[$i][$j]['SubmoduleID'] = $r['SubmoduleID'];
					$studentsHandled[$i][$j]['Rate'] = $r['Rate'];
			}
			$studentsHandled[$i]['RateCount'] = $j;
        }

        echo Debug::vars($studentsHandled);

        $twig->tableRate = $studentsHandled;
        $twig->groups = $groups;

        $twig->studyGroupID = $this->GetSGID($id);

		$this->response->body($twig);
    }
}
            